#ifndef _DEF_LEVEL
#define _DEF_LEVEL

#include <gint/defs/types.h>

typedef struct Level {
	int width;  /* in tiles */
	int height; /* in tiles */
	const uint8_t **layers; /* points toward the level content */
	int layers_count;
	uint solid_layer; /* id of the solid layer */
} Level;

#include "camera.h"

void level_step(const Level *level);
void level_draw(const Level *level, Camera *camera);
void layer_draw(const Level *level, Camera *camera, uint layer_id);

#endif /* _DEF_LEVEL */
